package demo;

import melog.skript.*;
import java.util.*;

public class Zauberformel extends Denker
{
	public Zauberformel(Ich ich, int[] erinnerung, Land land, Nachricht[] nachrichten, Freund[] freunde, Feind[] feinde, Rohstoff[] rohstoffe, Turm[] turm, Wirkung[] angriffe)
	{	
		super(ich, erinnerung, land, nachrichten, freunde, feinde, rohstoffe, turm, angriffe);
	}
	
	@Override
	public void denke() //Beginn des Denkzyklusses
	{	
		switch(ich.typ)
		{
			case KNECHT: knecht(); break;
			
//			case WAECHTER: break;
//			case KUNDSCHAFTER: break;
//			case PIONIER: break;
//			
//			case EISGOLEM: break;
//			case WASSERGOLEM: break;
//			case FLUSSGIGANT: break;
//			
//			case BLITZGOLEM: break;
//			case LUFTGOLEM: break;
//			case HIMMELSGIGANT: break;
//			
//			case ERDGOLEM: break;
//			case FEUERGOLEM: break;
//			case GEBIRGSGIGANT: break;
		}
	}
	
	@Override
	public void warnung() {}
	
	///////////////////////////////////////////////////////
	
	public void knecht() //Knechte sollen Holz sammeln und neue Einheiten bestellen
	{
		//sagt den anderen Knechten, wo es Baumbestand gibt
		if(!sucheBaum()) ich.sage(koorToInt(erinnerung[1], erinnerung[2]), Arrays.stream(freunde).filter(f -> f.typ == KNECHT).toArray(Freund[]::new));
		if(ich.holz >= 9) //wenn der Knecht genug Holz trägt
			if(ich.x * ich.x + ich.y * ich.y > 0.3) findeWeg(0, 0); //wenn nicht beim Turm, gehe dahin
			else //wenn beim Turm, gibt Holz ab und sucht neues
			{
				ich.lege();
				sucheBaum(true);
			}
		else //wenn nicht genug Holz (<9)
		{
			if(land.baum(ich)) //wenn das Land, auf dem er steht, ein Feld mit Baum ist
			{
				ich.stehe();
				ich.arbeite(); //fällen
			} else //er steht nicht auf einem Baumfeld
			{
				if(!sucheBaum() &&
				   !land.baum(xyDouble(erinnerung[1]), xyDouble(erinnerung[2])) &&
				   !land.nebel(xyDouble(erinnerung[1]), xyDouble(erinnerung[2]))) sucheBaum(true); //kein Baum mehr an aktueller Position
				if(sucheBaum()) guckNachBaum();
				for(Nachricht nach : nachrichten) //Nachrichten verarbeiten
				{
					int n = nach.nachricht;
					int x = intToX(n), y = intToY(n);
					if((land.baum(xyDouble(x), xyDouble(y)) || land.nebel(xyDouble(x), xyDouble(y))) //ignoriert veraltete Information
				    && ich.abstand(xyDouble(erinnerung[1]), xyDouble(erinnerung[2])) > ich.abstand(x, y)) //übernimmt den nächsten Baum
					{
						sucheBaum(false);
						erinnerung[1] = x;
						erinnerung[2] = y;
					}
				}
				if(sucheBaum()) guckNachNebel(); //kein bekannter Baum => deckt Nebel auf
				if(findeWeg(erinnerung[1], erinnerung[2]) == -1) //geht zum Baum oder Nebel seiner Wahl
				{
					debug("Keinen Weg gefunden\nx = " + erinnerung[1] + "\ny = " + erinnerung[2]);
					findeWeg(0, 0); //geht nach Hause um potenziell nächsten Baum zu finden
					sucheBaum(true);
				}
			}
		}
		
		if(meister != null) meister.macheKnecht(); //Turm in Sichtweite => bestellt neuen Knecht beim Meister
		
		if(sucheBaum()) ich.status("Suche Baum"); //stetzt In-Game-Status
		else ich.status("Kenne Baum");
	}
	
	
	private int koorToInt(int x, int y) { return ((x + 10000) * 100000) + (y + 10000); } //verpackt Koordinaten in ein int
	private int intToX(int koor) { return koor / 100000 - 10000; } //entpackt die x-Koordinate aus einem int
	private int intToY(int koor) { return koor % 100000 - 10000; } //entpackt die y-Koordinate aus einem int
	
	private boolean sucheBaum() { return erinnerung[0] == 0; } //gibt an, ob der Knecht ein Ziel hat
	private void sucheBaum(boolean suche) { erinnerung[0] = suche ? 0 : 1; } //setzt den Status, ob der Knecht ein Ziel hat
	
	private void guckNachBaum() { if(guckNachBewuchs(false, new byte[]{1, 2, 3, 4, 5, 6, 7, 8, 9})) sucheBaum(false); }
	private void guckNachNebel() { guckNachBewuchs(true); }
	public boolean guckNachBewuchs(boolean guckNachNebel, byte ...  bewuchs) //sucht radial um den aktuellen Standort den gewünschten Bewuchs oder Nebel
	{
		boolean nurNebel = false; //wenn alles Bekannte abgesucht, breche ab
		for(double r = 1; !nurNebel; r += 0.5) //erhöht den Suchradius
		{
			nurNebel = true;
			for(double phi = 0; phi < 2 * Math.PI; phi += Math.PI / (r + 1) / 2) //sucht entlang der Kreisbahn
			{
				double x = r * Math.cos(phi), y = r * Math.sin(phi);
				boolean gefunden = false;
				if(guckNachNebel) { if(land.nebel(ich.x + x, ich.y + y)) gefunden = true; } //wenn Nebel gefunden
				else for(byte b : bewuchs) if(land.bewuchs(ich.x + x, ich.y + y) == b) gefunden = true; //wenn gewünschter Bewuchs gefunden
				if(gefunden)
				{ //speichert den gefundenen Ort
					erinnerung[1] = xyInt(ich.x + x);
					erinnerung[2] = xyInt(ich.y + y);
					return true;
				}
				if(!land.nebel(ich.x + x, ich.y + y)) nurNebel = false; //Suche geht weiter
			}
		}
		return false; //gewünschter Bewuchs nicht gefunden
	}

	public double findeWeg(double zx, double zy) //findet einen besten Weg mithilfe eines abgewandelten A*-Algorithmus
	{
		if(land.fluss(zx, zy) || land.meer(zx, zy)) return -1;
		class Kasten implements Comparable<Kasten> //repräsentiert einen Knotenpunkt
		{
			public double x, y, g, f; //x, y: Ort, g: bisher kürzeste Entfernung, f: g + restliche Luftlinie
			
			public Kasten(double x, double y, double g, double f) //Kastenkonstruktor
			{
				this.x = x;
				this.y = y;
				this.g = g;
				this.f = f;
			}
			//Kästen werden nach ihren f-Werten geordnet
			public int compareTo(Kasten k)
			{
				double diff = this.f - k.f;
				return diff < 0 ? -1 : (diff > 0 ? 1 : 0);
			}
			//Identitätstoleranz von 0.1 aufgrund möglicher Rundungsfehler beim Rechnen
			@Override
			public boolean equals(Object kasten)
			{
				return (kasten instanceof Kasten) == abstand(((Kasten)kasten).x, ((Kasten)kasten).y, x, y) < 0.1;
			}
		}
		PriorityQueue<Kasten> openlist = new PriorityQueue<Kasten>(10, new Comparator<Kasten>()
		{
			public int compare(Kasten k1, Kasten k2) { return (int)Math.ceil(k1.f - k2.f); } //vergleicht f-Werte
		});
		TreeSet<Kasten> closedlist = new TreeSet<Kasten>();
		openlist.add(new Kasten(xyMid(zx),xyMid(zy), 0, 0)); //startet die Suche beim Ziel zwecks Abkürzungen
		while(!openlist.isEmpty()) //untersucht jeweils den nächsten besten Kandidaten,  bis keiner mehr da ist
		{
			Kasten aktuell = openlist.poll();
			double x = aktuell.x, y = aktuell.y;
			if(wegBegehbar(x, y, ich.x, ich.y)) //direkte Verbindung ab hier möglich
			{
				ich.geheZu(x, y); //Laufbefehl
				return aktuell.f; //geschätzte Entfernung
			}
			closedlist.add(aktuell); //ist untersucht worden und es gibt keine direkte Verbindung zum Golem
			//Suche pflanzt sich fort
			Kasten[] nachfolgerListe = new Kasten[]{new Kasten(x + 1, y, 0, 0), new Kasten(x, y + 1, 0, 0), new Kasten(x - 1, y, 0, 0), new Kasten(x, y - 1, 0, 0)};
			label: for(Kasten nachfolger : nachfolgerListe) if(!(land.fluss(nachfolger.x, nachfolger.y) || land.meer(nachfolger.x, nachfolger.y)))
			{
				for(Kasten untersucht : closedlist) if(untersucht.equals(nachfolger)) continue label;
				double g = aktuell.g + 1; //bisher zurückgelegter Weg
				double f = g + abstand(nachfolger.x, nachfolger.y, ich.x, ich.y);
				boolean kastenNeu = true;
				for(Kasten offen : openlist) if(offen.equals(nachfolger))
				{
					if(offen.g > g) //kürzerer Weg gefunden
					{
						offen.g = g;
						offen.f = f;
					}
					kastenNeu = false;
				}
				if(kastenNeu) //füge den Nachfolger der openlist hinzu
				{
					nachfolger.g = g;
					nachfolger.f = f;
					openlist.add(nachfolger);
				}
			 }
		}
		return -1; //Kein Weg gefunden
	}
	
	private boolean wegBegehbar(double x1, double y1, double x2, double y2) //testet, ob eine Luftlinie begehbar ist
	{
		double rX = x2 - x1, rY = y2 - y1; //Verbindung
		double abs = Math.sqrt(rX * rX + rY * rY); //Abstand
		if(abs == 0) return !(land.fluss(x1, y1) || land.meer(x1, y1)); //Sonderfall
	    rX /= abs; rY /= abs; double sx = Math.signum(rX), sy = Math.signum(rY), rpx = sx * rX, rpy = sy * rY; //normierte Größen und Vorzeichen
		do
		{
		    if(land.fluss(x1, y1) || land.meer(x1, y1)) return false; //Fluss- oder Meerfeld gefunden
			double kx = (x1 + 1000000.5) % 1, ky = (y1 + 1000000.5) % 1; //Ort innerhalb des Kästchens
			double kpx = sx < 0 ? 1 - kx : kx, kpy = sy < 0 ? 1 - ky : ky; //Ort wird mit rp mitgespiegelt
			Stack<Double> ps = new Stack<Double>(); //Liste der Schrittlängen, die in angrenzende Felder führen
			if(rpx != 0) { double l = (1 - kpx) / rpx; if(kpx < 1) ps.push(l); ps.push(l + 1 / rpx); } //Schrittlängen ins nächste und übernächste Feld in x-Richtung
			if(rpy != 0) { double l = (1 - kpy) / rpy; if(kpy < 1) ps.push(l); ps.push(l + 1 / rpy); } //Schrittlängen ins nächste und übernächste Feld in y-Richtung
			double p1 = 0.1, p2 = 0.1; //die beiden kleinsten Schrittlängen
			if(ps.size() >= 2) //wenn nicht, Sonderfall
			{
				ps.sort((d1, d2) ->
				{ //ordnet die Entfernungen
					double diff = d2 - d1;
					return diff < 0 ? -1 : (diff > 0 ? 1 : 0);
				});
				p1 = ps.pop(); p2 = ps.pop();
			}
			x1 += rX * (p1 + p2) / 2; y1 += rY * (p1 + p2) / 2; //gehe in die Mitte der ersten beiden Schrittlängen
		} while((x2 - x1) * rX + (y2 - y1) * rY >= 0); //solange noch nicht das Ziel überschritten
		return true; //kein Fluss- oder Meerfeld auf dem Weg
	}
	
	public static void main(String[] args)
	{
		start("demo.Zauberformel", "demo.Zauberformel");
	}
} //Ende Zauberformel